"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildAsXPageByBuildType = exports.buildAsAdminPortalByBuildType = exports.buildAsWebByBuildType = exports.WebpackModeType = exports.GenerateMpType = exports.BuildType = void 0;
var BuildType;
(function (BuildType) {
    BuildType["PC"] = "pc";
    BuildType["ADMIN_PORTAL"] = "adminPortal";
    BuildType["WEB"] = "web";
    BuildType["MP"] = "mp";
    BuildType["APP"] = "app";
    BuildType["WECHAT_H5"] = "wxH5";
    BuildType["WECHAT_WORK_H5"] = "qywxH5";
    BuildType["XPAGE_PC"] = "xPagePC";
})(BuildType = exports.BuildType || (exports.BuildType = {}));
var GenerateMpType;
(function (GenerateMpType) {
    GenerateMpType["APP"] = "app";
    GenerateMpType["SUBPACKAGE"] = "subpackage";
})(GenerateMpType = exports.GenerateMpType || (exports.GenerateMpType = {}));
var WebpackModeType;
(function (WebpackModeType) {
    WebpackModeType["NONE"] = "";
    WebpackModeType["PRODUCTION"] = "production";
})(WebpackModeType = exports.WebpackModeType || (exports.WebpackModeType = {}));
const buildAsWebByBuildType = (buildTypeList = []) => {
    return (buildTypeList.includes(BuildType.WEB) ||
        buildTypeList.includes(BuildType.PC) ||
        buildTypeList.includes(BuildType.ADMIN_PORTAL) ||
        buildTypeList.includes(BuildType.APP) ||
        buildTypeList.includes(BuildType.WECHAT_WORK_H5) ||
        buildTypeList.includes(BuildType.WECHAT_H5) ||
        buildTypeList.includes(BuildType.XPAGE_PC));
};
exports.buildAsWebByBuildType = buildAsWebByBuildType;
const buildAsAdminPortalByBuildType = (buildTypeList = []) => {
    return buildTypeList.includes(BuildType.ADMIN_PORTAL);
};
exports.buildAsAdminPortalByBuildType = buildAsAdminPortalByBuildType;
const buildAsXPageByBuildType = (buildTypeList = []) => {
    return buildTypeList.includes(BuildType.XPAGE_PC);
};
exports.buildAsXPageByBuildType = buildAsXPageByBuildType;
