"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.walkThroughWidgets = void 0;
function walkThroughWidgets(widgets, fn, currentId) {
    var _a;
    for (const id in widgets) {
        const { xComponent, xProps } = widgets[id];
        const { directives } = xProps || {};
        if (((_a = directives === null || directives === void 0 ? void 0 : directives.waIf) === null || _a === void 0 ? void 0 : _a.value) === false) {
            continue;
        }
        const isSlot = !xComponent;
        !isSlot && fn(id, widgets[id], currentId);
        /**
         * properties 可能会发生变更
         * 因此要在 fn 之后
         */
        const children = widgets[id].properties;
        children && walkThroughWidgets(children, fn, isSlot ? currentId : id);
    }
}
exports.walkThroughWidgets = walkThroughWidgets;
